var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React, { forwardRef, useRef, useImperativeHandle, useEffect } from 'react';
import ImgLazy from './../ImgLazy';

var Container = forwardRef(function (_ref, ref) {
  var lazyLoad = _ref.lazyLoad,
      children = _ref.children,
      others = _objectWithoutProperties(_ref, ['lazyLoad', 'children']);

  var refEl = useRef(null);
  useImperativeHandle(ref, function () {
    return refEl.current;
  });

  // 图片懒加载
  var lazyInstance = useRef(null);
  useEffect(function () {
    if (lazyLoad !== 'scroll' && lazyLoad !== 'queue') return;
    if (lazyInstance.current) {
      lazyInstance.current.load();
    } else {
      lazyInstance.current = new ImgLazy({
        overflowContainer: refEl.current,
        load: lazyLoad
      });
      lazyInstance.current.load();
    }
  }, [children]); // eslint-disable-line

  return React.createElement(
    'article',
    _extends({ ref: refEl }, others, { className: 'container' + (others.className ? ' ' + others.className : '') }),
    children
  );
});

export default Container;